SystemOrganization addCategory: #'TADP-Meta-programacion-tp'!
SystemOrganization addCategory: #'TADP-Meta-programacion-tp-test'!
SystemOrganization addCategory: #'TADP-Meta-programacion-tp-campo'!

TestCase subclass: #TestClassSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp-test'!

!TestClassSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/3/2013 23:59'!
testGetClassUsingDummySelector
	|selector ret |
	selector := DummyClassSelector new.

	ret := selector selectClass detect: [ :each | each = Gauchita class]  ifNone: nil.
	
	self assert:  (ret = Gauchita class).! !

!TestClassSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:16'!
testGetNoneClassUsingDummySelector
	|selector ret |
	selector := DummyClassSelector new.

	ret := selector selectClass detect: [ :each | each = Intocable class]  ifNone: nil.
	
	self assert:  (ret isNil).! !

TestCase subclass: #TestInterceptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp-test'!

!TestInterceptor methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 03:59'!
testIntercpetSomething
	|interceptor aClassSelector aMethodSelector subset methods aMethodBefore aMethodAfter |
	interceptor := Interceptor new.
	aClassSelector := PackageClassSelector new.
	aMethodSelector := DummyMethodSelector  new.
	
	interceptor methodSelector: aMethodSelector .
	interceptor classSelector: aClassSelector .
	
	aMethodBefore:= 'Transcript show: ''antes'' ;cr.'.
	aMethodAfter:= 'Transcript show: ''despues'' ;cr.'.
	
	interceptor interceptWith: aMethodBefore and: aMethodAfter.
	
	! !

!TestInterceptor methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:45'!
testSubsetOfClassAndMethodsUniverse
	|interceptor aClassSelector aMethodSelector subset methods |
	interceptor := Interceptor new.
	aClassSelector := DummyClassSelector new.
	aMethodSelector := DummyMethodSelector  new.
	
	subset:= interceptor getClassAndMethodsFromTheUniverseWith: aClassSelector and: aMethodSelector.
	
	self shouldnt:(subset isNil).
	self deny: (subset keys detect: [:each | each = (Gauchita class)] ifNone: nil) isNil .
	
	methods := subset at:(Gauchita class).
	
	self deny: (methods detect: [:met | met = #dumbSelector] ifNone: nil ) isNil.! !

!TestInterceptor methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 04:56'!
testWrapCebadaDeMate
	|interceptor aClassSelector aMethodSelector subset methods gauchita sourceBkp metBkp |
	interceptor := Interceptor new.
	
      	metBkp :=Gauchita >> #cebateUnMate.
	sourceBkp:= metBkp getSource.
	
	gauchita:= Gauchita new.
	gauchita cebateUnMate.
	
	interceptor wrapMethod: #cebateUnMate 
			    ofClass: Gauchita 
			    callingBefore: 'Transcript show: ''pop'';cr.' 
			    andCallingAfter:	'Transcript show: ''eye''.'.
	
	gauchita cebateUnMate.
	
	Gauchita compile: metBkp.! !

TestCase subclass: #TestMethodSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp-test'!

!TestMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 05:03'!
testGetAccesorsMethod
	|selector ret |
	selector := AccessorsMethodSelector new.
	
	ret := (selector selectMethodFrom: Aire) detect:[:each | each = #movete]  ifNone: nil .
	
	self assert:  (ret isNil).
	
	ret := (selector selectMethodFrom: Aire) detect:[:each | each = #limpio]  ifNone: nil .
	
	self deny:  (ret isNil).! !

!TestMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 04:35'!
testGetMethodStartingWithA
	|selector ret |
	selector := StartingWhitMethodSelector new.
	selector prefix: 'a'.
		
	ret := (selector selectMethodFrom: Arbol) detect:[:each | 
													|woSlash|
													woSlash:= each name asString copyReplaceAll: '#' with: ''. 
													woSlash beginsWith: 'a']  ifNone: nil .
	
	self assert:  (ret isNil).! !

!TestMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 04:37'!
testGetMethodStartingWithR
	|selector ret |
	selector := StartingWhitMethodSelector new.
	selector prefix: 'r'.
		
	ret := (selector selectMethodFrom: Arbol) detect:[:each | 
													|woSlash|
													woSlash:= each name asString copyReplaceAll: '#' with: ''. 
													woSlash beginsWith: 'r']  ifNone: nil .
	
	self deny:  (ret isNil).! !

!TestMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:25'!
testGetMethodUsinngDummySelector
	|selector ret |
	selector := DummyMethodSelector new.
	
	ret := (selector selectMethodFrom: Gauchita class) detect:[:each | each = #dummySelector]  ifNone: nil .
	
	self assert:  (#dummySelector = ret).! !

!TestMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:26'!
testGetNoMethodUsinngDummySelector
	|selector ret |
	selector := DummyMethodSelector new.
	
	ret := (selector selectMethodFrom: Gauchita class) detect:[:each | each = #smartSelector]  ifNone: nil .
	
	self assert:  (ret isNil).! !

Object subclass: #Aire
	instanceVariableNames: 'limpio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp-campo'!

!Aire methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 04:21'!
limpio
	^ limpio! !

!Aire methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 04:21'!
limpio: anObject
	limpio := anObject! !

!Aire methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 04:59'!
movete
	^true! !

Object subclass: #Arbol
	instanceVariableNames: 'hojas ramas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp-campo'!

!Arbol methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 04:21'!
hojas
	^ hojas! !

!Arbol methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 04:21'!
hojas: anObject
	hojas := anObject! !

!Arbol methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 04:22'!
ramas
	^ ramas! !

!Arbol methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 04:22'!
ramas: anObject
	ramas := anObject! !

Object subclass: #ClassSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!ClassSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/3/2013 23:59'!
selectClass
	|classes|
	classes := Set new.
	
	^classes.! !

ClassSelector subclass: #DummyClassSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!DummyClassSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:46'!
selectClass
	|classes|
	classes := Set new.
	classes add: (Gauchita class) .
	classes add: (QueTocas class) .
	
	^classes.! !

ClassSelector subclass: #PackageClassSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!PackageClassSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 03:40'!
selectClass 
	^(SystemOrganization listAtCategoryNamed: 'TADP-Meta-programacion-tp') collect: [:e | Smalltalk globals at: e].! !

Object subclass: #Gauchita
	instanceVariableNames: 'matesMaximos matesCebados nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!Gauchita methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 04:57'!
cebateUnMate
	self matesCebados: self matesCebados + 1. 
	Transcript show: 'cebando'.
	Transcript show: self matesCebados;cr! !

!Gauchita methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 04:11'!
imprimiteAlgo
	Transcript show: 'Algo' ;cr.! !

!Gauchita methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 00:54'!
matesCebados
	matesCebados isNil ifTrue: [ self matesCebados: 0 ] .
	^ matesCebados.! !

!Gauchita methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 00:52'!
matesCebados: anObject
	matesCebados := anObject! !

!Gauchita methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 00:52'!
matesMaximos
	^ matesMaximos! !

!Gauchita methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 00:52'!
matesMaximos: anObject
	matesMaximos := anObject! !

!Gauchita methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 00:52'!
nombre
	^ nombre! !

!Gauchita methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 00:52'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Interceptor
	instanceVariableNames: 'methodSelector classSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/3/2013 21:57'!
classSelector
	^ classSelector! !

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/3/2013 21:57'!
classSelector: anObject
	classSelector := anObject! !

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 00:30'!
getClassAndMethodsFromTheUniverseWith: aClassSelector and: aMethodSelector
	|classToIntercept methodsToIntercept interceptionCenter|
	classToIntercept := Set new.
	interceptionCenter := Dictionary new.
	
	classToIntercept := aClassSelector selectClass.
	
	classToIntercept do: [:eachClass | interceptionCenter add: (Association key: eachClass  value: (aMethodSelector selectMethodFrom: eachClass) )].
	^interceptionCenter.! !

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 01:49'!
interceptWith: aMethodBefore and: aMethodAfter
	|classToIntercept methodsToIntercept interceptionCenter|
	interceptionCenter :=  self getClassAndMethodsFromTheUniverseWith: self classSelector and: self methodSelector.
	
	interceptionCenter keysAndValuesDo: [:aClass :someMethods | 
											someMethods do: [ :meth | 
														self wrapMethod:meth ofClass:aClass callingBefore: aMethodBefore andCallingAfter: aMethodAfter  ] 
													].! !

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/3/2013 21:57'!
methodSelector
	^ methodSelector! !

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/3/2013 21:57'!
methodSelector: anObject
	methodSelector := anObject! !

!Interceptor methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 04:57'!
wrapMethod:meth ofClass:aClass callingBefore: aMethodBefore andCallingAfter: aMethodAfter
	| sourCode compiledMeth methodName newMethodName newMethodSource |
	[compiledMeth:= aClass methodDict at: meth. ]
	on: Error 
	do: [^nil].
	
	sourCode:=  compiledMeth getSource.

	methodName:= meth asString copyReplaceAll: '#' with: ''. 
	newMethodName:='_',methodName.
	
	aClass compile:'_',sourCode. 
	
	newMethodSource:= methodName,'
	',aMethodBefore,'
	self ',newMethodName,'.
	',aMethodAfter .
	
	"Transcript show: newMethodSource;cr."
	
	aClass compile: newMethodSource. 
 ! !

Object subclass: #MethodSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

MethodSelector subclass: #AccessorsMethodSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!AccessorsMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 05:15'!
selectMethodFrom: aClass
	| varnames methos |
	varnames :=  aClass instVarNames.
	methos:= Set new.

	varnames do:[ :v | aClass methodDict keys do: [ :each | each name asString = ('#',v) ifTrue: [ methos add: each ] ifFalse: 											[ each name asString = ('#',v,':') ifTrue: [methos add: each]  ]  ]].

	^methos.! !

MethodSelector subclass: #DummyMethodSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!DummyMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 04:02'!
selectMethodFrom: aClass
	|methods|
	methods := Set new.
	methods add: #imprimiteAlgo.
	
	^methods.
! !

!MethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 00:20'!
selectMethodFrom: aClass
	|methods|
	methods := Set new.

	^methods.
	! !

!MethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/3/2013 00:25'!
selectMethodFrom: aClass startingWith: aText
	^[ aClass methodDict collect: [:each | each selector indexOfString aText] ]! !

MethodSelector subclass: #StartingWhitMethodSelector
	instanceVariableNames: 'prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta-programacion-tp'!

!StartingWhitMethodSelector methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 03:47'!
prefix
	^ prefix! !

!StartingWhitMethodSelector methodsFor: 'accessing' stamp: 'joseflores 5/4/2013 03:47'!
prefix: anObject
	prefix := anObject! !

!StartingWhitMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 03:46'!
selectMethodFrom: aClass
	^self selectMethodFrom: aClass startingWith: self prefix. ! !

!StartingWhitMethodSelector methodsFor: 'as yet unclassified' stamp: 'joseflores 5/4/2013 04:46'!
selectMethodFrom: aClass startingWith: aText
	^aClass methodDict keys select: [:each | each name asString beginsWith: '#',aText]
! !
